#include "fatfs.h"
#include "ch32v30x.h"
#include "FATFS/ff.h"
#include "string.h"
#include "stdlib.h"
#include "stdio.h"

unsigned char file_buff[30720];

FATFS fs;        /* FatFsļϵͳ */
FIL fnew;        /* ļ */
FRESULT res;     /* ļ */
UINT fnum;       /* ļɹд */

unsigned char File_Mount()
{
    res = f_mount(&fs,"0:",1);
    if(res == FR_NO_FILESYSTEM)
    {
        res=f_mkfs("0:",1,4096);
        if(res == FR_OK)
        {
            res = f_mount(((void *)0),"0:",1);
            res = f_mount(&fs,"0:",1);
            if(res == FR_OK) return 1;
        }
        else return 0;
    }
    else if(res!=FR_OK) return 0;
    return 1;
}

unsigned int File_Read(unsigned char file_name[])
{
    unsigned char file_path[15];
    sprintf(file_path, "0:%s", file_name);
    res = f_open(&fnew, file_path, FA_OPEN_EXISTING | FA_READ);
    if(res == FR_OK)
    {
        int size = f_size(&fnew);
        res = f_read(&fnew, file_buff, size, &fnum);
        f_close(&fnew);
        if(res==FR_OK) return size;
        else return 0;
    }
    return 0;
}

unsigned int File_Write(unsigned char file_name[], unsigned char data[], unsigned int size, unsigned char append)
{
    unsigned char file_path[15];
    sprintf(file_path, "0:%s", file_name);
    if(append)
    {
        res = f_open(&fnew, file_path, FA_OPEN_ALWAYS | FA_WRITE);
        f_lseek(&fnew, f_size(&fnew));
    }
    else res = f_open(&fnew, file_path, FA_CREATE_ALWAYS | FA_WRITE);
    if (res == FR_OK)
    {
        res=f_write(&fnew, data, size, &fnum);
        f_close(&fnew);
        if(res==FR_OK) return 1;
    }
    return 0;
}

unsigned int File_Size(unsigned char file_name[])
{
    unsigned char file_path[15];
    sprintf(file_path, "0:%s", file_name);
    res = f_open(&fnew, file_path, FA_READ);
    if(res != FR_OK) return 0;
    unsigned int size = f_size(&fnew);
    f_close(&fnew);
    return size;
}

unsigned char *File_Data()
{
    return file_buff;
}
