#include "ch32v30x.h"
#include "systick_timer.h"
#include "stdio.h"
#include "string.h"
#include "uart_debug.h"
#include "eth.h"
#include "stdlib.h"
#include "w25q.h"
#include "fatfs.h"

int main(void)
{
    Systick_Init();
    Uart_Debug_Init(921600);
    TIM2_Init();  //给WCHNET用的

    printf("begin\n");
    Delay(1000);

    File_Mount();   //初始化spi flash(w25q128), 挂载文件系统
    File_Write("cyc.tft", "", 0, 0); //清空一下这个文件数据，待会在循环里重新下载

    WCHNET_GetMacAddr(MACAddr);
    ETH_LibInit(IPAddr, GWIPAddr, IPMask, MACAddr);
    WCHNET_DHCPStart(WCHNET_DHCPCallBack);

    unsigned int rx_count = 0;

    //获得ip后，在WCHNET_HandleSockInt()发送HTTP请求到服务器获取文件

    while(1)
    {
        ///////////////////////////////////////
        ////////////////调试串口/////////////////
        ///////////////////////////////////////
        if(Uart_Debug_Received())
        {
            unsigned int rx_len = Uart_Debug_Received_Size();
            printf("uart rx_len: %d\n", rx_len);
            unsigned char rx_data[rx_len+1];
            memcpy(rx_data, Uart_Debug_Read(), rx_len);
            Uart_Debug_Clear_Flag();
            rx_data[rx_len] = '\0';
            printf(rx_data);
        }


        ////////////////////////////////////
        ////////////////以太网////////////////
        ////////////////////////////////////
        WCHNET_MainTask();
        if(WCHNET_QueryGlobalInt()) WCHNET_HandleGlobalInt();


        /////////////////////////////////////////////////
        ////////////////////接收服务端数据////////////////////
        /////////////////////////////////////////////////
        if(Eth_Receive())
        {
            unsigned int recv_len = Eth_Receive_Len();   //
            unsigned char recv_data[recv_len+1];
            memcpy(recv_data, Eth_Receive_Data(), recv_len);
            recv_data[recv_len] = '\0';
            Eth_Receive_Clear();
            rx_count+=recv_len;
            File_Write("cyc.tft", recv_data, recv_len, 1);  //追加数据到文件末尾，加上这个会导致接收以太网数据延迟。表现跟delay 3ms类似，delay 1ms的时候就没问题。
//            Delay(3);
            printf("%d\n", rx_count);
        }
    }
}

